# Remaining issues:
#
# [U] = should be done at/by upstream simpleSAMLphp
#
# - [U] how to enable modules? writing an "enable" file in 
#   /usr/share/simplesamlphp/modules/<NAME> is NOT a solution, enable them 
#   through some config file in /etc/simplesamlphp IS.
#   PATCH provided: http://code.google.com/p/simplesamlphp/issues/detail?id=475
# - [U] we really cannot set a default pw from the post section! We should 
#   probably patch and upstream a simpleSAMLphp fail (or warning in web 
#   interface, like when using HTTP instead of HTTPS if the default salt value 
#   is still there. Other options: use Debian approach with separate secrets
#   PATCH provided: http://code.google.com/p/simplesamlphp/issues/detail?id=476
# - the default certs are probably a bad idea! maybe not install them? of fail
#   if they were not replaced? Maybe we can generate some certificates, like
#   is done for the dovecot IMAP server package...
# - certs need to be moved to /etc/pki/simplesamlphp  (like e.g. dovecot case)
# - deal with SELinux (try to enable metarefresh to make sure it actually 
#   works and write stuff to /var/lib/simplesamlphp/metadata) also fix default
#   metarefresh default location to write metadata perhaps...
# - deal with the logfile in /var/log/simplesamlphp
# - get rid of the included copy of OpenID php and libxmlsec PHP stuff in the 
#   lib/ directory, package them separately!
# - also get rid of included jquery, jquery-ui library
# - do something with the cron stuff, maybe already prepare cron.d entries? 
# - fix attributemap, is this still needed? if the user needs to modify this 
#   it should really go to /etc/simplesamlphp. Debian has it in 
#   /etc/simplesamlphp
# - add a README.dist including information about setting the salt, the 
#   password, module enablement, SELinux and enabling the various plugins...
# - [U] fix the execute bit on non-scripts
# - [U] make it possible to modify the paths in config.php to the config and
#   metadata directory so symlinks are no longer needed
#   ISSUE: http://code.google.com/p/simplesamlphp/issues/detail?id=349
# - fix the license info, there are lots of licenses involved in this project
#   see the Debian package for a list of licenses...
# - somehow make this package work with previously created RPM packages 
#   (smooth upgrade path)

Name:		simplesamlphp
Version:	1.8.2
Release:	1%{?dist}
Summary:	PHP SAML 2.0 service provider and identity provider

Group:		Applications/Internet
License:	LGPLv2
URL:		http://simplesamlphp.org/
Source0:	http://simplesamlphp.googlecode.com/files/simplesamlphp-%{version}.tar.gz
Source1:	simplesamlphp-httpd-conf
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

Requires:	webserver
Requires:	php >= 5.2.0
Requires:	php-ldap
Requires:	php-xml
Requires:	php-pdo
Requires:	php-mcrypt
Requires:	php-mysql
Requires:	php-pecl-radius

BuildArch:	noarch
 
%description
SimpleSAMLphp is an award-winning application written in native PHP 
that deals with authentication. The project is led by UNINETT, has a 
large user base, a helpful user community and a large set of 
external contributors.

SimpleSAMLphp is having a main focus on providing support for:

    SAML 2.0 as a Service Provider.
    SAML 2.0 as a Identity Provider.

But also supports some other identity protocols, such as Shibboleth 
1.3, A-Select, CAS, OpenID, WS-Federation and OAuth.

%prep
%setup -q

# fix execute permission on some files (shamelessly taken from Debian package)
find . -type f -executable -not -path '*/bin/*' | xargs chmod -x

%build

%install
rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/cert
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/metadata
mkdir -p ${RPM_BUILD_ROOT}%{_datadir}/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}/data
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name}/metadata

install -m 0644 -D -p %{SOURCE1} ${RPM_BUILD_ROOT}%{_sysconfdir}/httpd/conf.d/%{name}.conf

cp -pr config-templates/* ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}
cp -pr metadata-templates/* ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/metadata
cp -pr cert/* ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/cert

# fix config
sed -i "s|'baseurlpath'           => 'simplesaml/'|'baseurlpath'           => 'simplesamlphp/'|g" ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/config.php
sed -i "s|'datadir'               => 'data/'|'datadir'               => '/var/lib/simplesamlphp/data/'|g" ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/config.php
sed -i "s|'loggingdir'            => 'log/'|'loggingdir'            => '/var/log/simplesamlphp/'|g" ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/config.php
sed -i "s|'certdir'               => 'cert/'|'certdir'               => '/etc/simplesamlphp/cert/'|g" ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/config.php

cp -pr * ${RPM_BUILD_ROOT}%{_datadir}/%{name}

rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/config 
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/metadata 
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/data 
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/cert
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/log 
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/docs
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/COPYING

ln -sf ../../../etc/simplesamlphp ${RPM_BUILD_ROOT}%{_datadir}/simplesamlphp/config
ln -sf ../../../etc/simplesamlphp/metadata ${RPM_BUILD_ROOT}%{_datadir}/simplesamlphp/metadata

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}
%{_datadir}/%{name}
%{_localstatedir}/lib/%{name}
%doc docs/ COPYING

%changelog
* Wed Feb 11 2012 F. Kooman <fkooman@tuxed.net> - 1.8.2-1
- initial package based on previous work by Gijs Molenaar, Xander Jansen,
  Victoriano Giralt (RPM package) and Thijs Kinkhorst (Debian package).

